{*************************************************

  Super Calendar Set Demo by Andrew J. McGee
  E-Mail: jaym25@3ptech.com
  Last Revision Date: 7/29/98

  Copyright (c) 1998 by Andrew J. McGee
  This Source Code may not be distributed to any other person
  without the express written permission of the Author

  The Author may also be contacted via snail mail:
     PO Box 80336
     Baton Rouge, LA 70898 USA
***************************************************}

unit SCalDemo1;
{$A+,B-,G+,H+,O+,J-,T+,U-,V+,W-,X+} //Set up compiler
{$D-,L-,Q-,R-,Y-} //Comment out to debug

interface

uses
  Windows, Classes, SysUtils, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, CommCtrl, SCalSet, Mask,
  STools;

type
  TfrmDemo1 = class(TForm)
    gbColor: TGroupBox;
    ButtonColorCalCtrl: TButton;
    ButtonColorCalPop: TButton;
    ButtonColorCalEdit: TButton;
    gbFont: TGroupBox;
    ButtonFontCalPopup: TButton;
    ButtonFontCECal: TButton;
    gbOptions: TGroupBox;
    cbNoToday: TCheckBox;
    cbNoTCircle: TCheckBox;
    gbBorder: TRadioGroup;
    SCalPopup1: TSCalPopup;
    ButtonFontCEEdit: TButton;
    AreaSelectBox: TComboBox;
    Panel1: TPanel;
    Label1: TLabel;
    SCalControl1: TSCalControl;
    ButtonFontCalControl: TButton;
    cbWeekNumbers: TCheckBox;
    cbMultiSelect: TCheckBox;
    StartDate: TMaskEdit;
    EndDate: TMaskEdit;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    ceStartDate: TMaskEdit;
    Label6: TLabel;
    ceEndDate: TMaskEdit;
    GroupBox4: TGroupBox;
    cbFloat: TCheckBox;
    cbQuick: TCheckBox;
    rgShowButton: TRadioGroup;
    rgButtonPos: TRadioGroup;
    rgBorderStyle2: TRadioGroup;
    Panel3: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Bevel1: TBevel;
    FocusOnClick: TCheckBox;
    MaskEdit2: TMaskEdit;
    MaskEdit1: TMaskEdit;
    MaskEdit3: TMaskEdit;
    MaskEdit4: TMaskEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    cpFloat: TCheckBox;
    Label13: TLabel;
    Bevel2: TBevel;
    cbSpin: TCheckBox;
    rgModeDT: TRadioGroup;
    SCalEdit1: TSCalEdit;
    TabControl1: TTabControl;
    Memo3: TMemo;
    Memo1: TMemo;
    Memo2: TMemo;
    cbBoldDays: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonColorCalCtrlClick(Sender: TObject);
    procedure ButtonColorCalPopClick(Sender: TObject);
    procedure ButtonColorCalEditClick(Sender: TObject);
    procedure ButtonFontCalPopupClick(Sender: TObject);
    procedure ButtonFontCEEditClick(Sender: TObject);
    procedure ButtonFontCECalClick(Sender: TObject);
    procedure gbBorderClick(Sender: TObject);
    procedure ButtonFontCalControlClick(Sender: TObject);
    procedure cbNoTodayClick(Sender: TObject);
    procedure cbNoTCircleClick(Sender: TObject);
    procedure cbWeekNumbersClick(Sender: TObject);
    procedure cbMultiSelectClick(Sender: TObject);
    procedure SCalControl1SelectDate(Sender: TObject);
    procedure StartDateExit(Sender: TObject);
    procedure EndDateExit(Sender: TObject);
    procedure SCalEdit1SelectDate(Sender: TObject);
    procedure ceStartDateExit(Sender: TObject);
    procedure ceEndDateExit(Sender: TObject);
    procedure rgShowButtonClick(Sender: TObject);
    procedure rgButtonPosClick(Sender: TObject);
    procedure rgBorderStyle2Click(Sender: TObject);
    procedure cbFloatClick(Sender: TObject);
    procedure cbQuickClick(Sender: TObject);
    procedure SCalEdit1DblClick(Sender: TObject);
    procedure Label8DblClick(Sender: TObject);
    procedure FocusOnClickClick(Sender: TObject);
    procedure MaskEdit1DblClick(Sender: TObject);
    procedure MaskEdit2DblClick(Sender: TObject);
    procedure MaskEdit3DblClick(Sender: TObject);
    procedure MaskEdit4DblClick(Sender: TObject);
    procedure SCalPopup1SelectDate(Sender: TObject);
    procedure cpFloatClick(Sender: TObject);
    procedure cbSpinClick(Sender: TObject);
    procedure rgModeDTClick(Sender: TObject);
    procedure SCalEdit1SelectTime(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure SCalEdit1GetMonthInfo(Sender: TObject; Month: Integer;
      var MonthBoldInfo: LongInt);
    procedure SCalControl1GetMonthInfo(Sender: TObject; Month: Integer;
      var MonthBoldInfo: LongInt);
    procedure cbBoldDaysClick(Sender: TObject);
    procedure SCalEdit1Exit(Sender: TObject);
    procedure SCalEdit1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SCalEdit1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SCalEdit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SCalControl1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SCalControl1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SCalControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
  end;

var
  frmDemo1: TfrmDemo1;

implementation

{$R *.DFM}

procedure TfrmDemo1.FormCreate(Sender: TObject);
begin
  AreaSelectBox.ItemIndex:=0;
  StartDate.Text:=FormatDateTime('ddddd',SCalControl1.SelDate);
  EndDate.Text:=FormatDateTime('ddddd',SCalControl1.SelDateEnd);
  ceStartDate.Text:=FormatDateTime('ddddd',SCalEdit1.SelDate);
  ceEndDate.Text:=FormatDateTime('ddddd',SCalEdit1.SelDateEnd);
  MaskEdit1.Text:=FormatDateTime('ddddd',26189);
  MaskEdit2.Text:=FormatDateTime('ddddd',34811);
  MaskEdit3.Text:=FormatDateTime('ddddd',35431);
  MaskEdit4.Text:=FormatDateTime('ddddd',35504);
  SCalEdit1.Text:='Drop Date Here!';
end;

procedure TfrmDemo1.FormShow(Sender: TObject);
begin
  TabControl1.SetFocus;
end;

procedure TfrmDemo1.ButtonColorCalCtrlClick(Sender: TObject);
begin
  with TColorDialog.Create(Application) do try
    Case AreaSelectBox.ItemIndex of
      0: Color:=SCalControl1.Colors.MonthBackColor;
      1: Color:=SCalControl1.Colors.BorderColor;
      2: Color:=SCalControl1.Colors.TextColor;
      3: Color:=SCalControl1.Colors.TitleBackColor;
      4: Color:=SCalControl1.Colors.TitleTextColor;
      5: Color:=SCalControl1.Colors.TrailingTextColor; end; //case;
    if Execute then
      Case AreaSelectBox.ItemIndex of
        0: SCalControl1.Colors.MonthBackColor:=Color;
        1: SCalControl1.Colors.BorderColor:=Color;
        2: SCalControl1.Colors.TextColor:=Color;
        3: SCalControl1.Colors.TitleBackColor:=Color;
        4: SCalControl1.Colors.TitleTextColor:=Color;
        5: SCalControl1.Colors.TrailingTextColor:=Color; end; //case;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonColorCalPopClick(Sender: TObject);
begin
  with TColorDialog.Create(Application) do try
    Case AreaSelectBox.ItemIndex of
      0: Color:=SCalPopup1.Colors.MonthBackColor;
      1: Color:=SCalPopup1.Colors.BorderColor;
      2: Color:=SCalPopup1.Colors.TextColor;
      3: Color:=SCalPopup1.Colors.TitleBackColor;
      4: Color:=SCalPopup1.Colors.TitleTextColor;
      5: Color:=SCalPopup1.Colors.TrailingTextColor; end; //case;
    if Execute then begin
      Case AreaSelectBox.ItemIndex of
        0: SCalPopup1.Colors.MonthBackColor:=Color;
        1: SCalPopup1.Colors.BorderColor:=Color;
        2: SCalPopup1.Colors.TextColor:=Color;
        3: SCalPopup1.Colors.TitleBackColor:=Color;
        4: SCalPopup1.Colors.TitleTextColor:=Color;
        5: SCalPopup1.Colors.TrailingTextColor:=Color; end; //case;
      SCalPopup1.Execute(nil); end;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonColorCalEditClick(Sender: TObject);
begin
  with TColorDialog.Create(Application) do try
    Case AreaSelectBox.ItemIndex of
      0: Color:=SCalEdit1.Calendar.Colors.MonthBackColor;
      1: Color:=SCalEdit1.Calendar.Colors.BorderColor;
      2: Color:=SCalEdit1.Calendar.Colors.TextColor;
      3: Color:=SCalEdit1.Calendar.Colors.TitleBackColor;
      4: Color:=SCalEdit1.Calendar.Colors.TitleTextColor;
      5: Color:=SCalEdit1.Calendar.Colors.TrailingTextColor; end; //case;
    if Execute then begin
      Case AreaSelectBox.ItemIndex of
        0: SCalEdit1.Calendar.Colors.MonthBackColor:=Color;
        1: SCalEdit1.Calendar.Colors.BorderColor:=Color;
        2: SCalEdit1.Calendar.Colors.TextColor:=Color;
        3: SCalEdit1.Calendar.Colors.TitleBackColor:=Color;
        4: SCalEdit1.Calendar.Colors.TitleTextColor:=Color;
        5: SCalEdit1.Calendar.Colors.TrailingTextColor:=Color; end; //case;
      SCalEdit1.DisplayForm(nil); end;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonFontCalControlClick(Sender: TObject);
begin
  with TFontDialog.Create(Application) do try
    Font:= SCalControl1.Font;
    if Execute then SCalControl1.Font:= Font;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonFontCalPopupClick(Sender: TObject);
begin
  with TFontDialog.Create(Application) do try
    Font:= SCalPopup1.Font;
    if Execute then SCalPopup1.Font:= Font;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonFontCEEditClick(Sender: TObject);
begin
  with TFontDialog.Create(Application) do try
    Font:= SCalEdit1.Font;
    if Execute then SCalEdit1.Font:= Font;
  finally Free; end;
end;

procedure TfrmDemo1.ButtonFontCECalClick(Sender: TObject);
begin
  with TFontDialog.Create(Application) do try
    Font:= SCalEdit1.Calendar.Font;
    if Execute then SCalEdit1.Calendar.Font:= Font;
  finally Free; end;
end;

procedure TfrmDemo1.gbBorderClick(Sender: TObject);
begin
  Case gbBorder.ItemIndex of
    0: begin
      SCalControl1.BorderStyle:=bsNone;
      SCalPopup1.BorderStyle:=bsNone;
      SCalEdit1.Calendar.BorderStyle:=bsNone; end;
    1: begin
      With SCalControl1 do begin
        BorderStyle:=bsSingle; Ctl3D:=False; end;
      With SCalPopup1 do begin
        BorderStyle:=bsSingle; Ctl3D:=False; end;
      With SCalEdit1.Calendar do begin
        BorderStyle:=bsSingle; Ctl3D:=False; end; end;
    2: begin
      With SCalControl1 do begin
        BorderStyle:=bsSingle; Ctl3D:=True; end;
      With SCalPopup1 do begin
        BorderStyle:=bsSingle; Ctl3D:=True; end;
      With SCalEdit1.Calendar do begin
        BorderStyle:=bsSingle; Ctl3D:=True; end; end;
  end; // Case
end;

procedure TfrmDemo1.cbNoTodayClick(Sender: TObject);
begin
    SCalControl1.Options.NoToday:=cbNoToday.Checked;
    SCalPopup1.Options.NoToday:=cbNoToday.Checked;
    SCalEdit1.Calendar.Options.NoToday:=cbNoToday.Checked;
end;

procedure TfrmDemo1.cbNoTCircleClick(Sender: TObject);
begin
    SCalControl1.Options.NoTodayCircle:=cbNoTCircle.Checked;
    SCalPopup1.Options.NoTodayCircle:=cbNoTCircle.Checked;
    SCalEdit1.Calendar.Options.NoTodayCircle:=cbNoTCircle.Checked;
end;

procedure TfrmDemo1.cbWeekNumbersClick(Sender: TObject);
begin
  SCalControl1.Options.WeekNumbers:=cbWeekNumbers.Checked;
  SCalPopup1.Options.WeekNumbers:=cbWeekNumbers.Checked;
  SCalEdit1.Calendar.Options.WeekNumbers:=cbWeekNumbers.Checked;
  if cbWeekNumbers.Checked then SCalControl1.NumMonthsAcross:=1
  else SCalControl1.NumMonthsAcross:=2;
end;


procedure TfrmDemo1.cbMultiSelectClick(Sender: TObject);
begin
  SCalControl1.Options.MultiSelect:=cbMultiSelect.Checked;
  SCalPopup1.Options.MultiSelect:=cbMultiSelect.Checked;
  SCalEdit1.Calendar.Options.MultiSelect:=cbMultiSelect.Checked;
end;


procedure TfrmDemo1.SCalControl1SelectDate(Sender: TObject);
begin
  StartDate.Text:=FormatDateTime('ddddd',SCalControl1.SelDate);
  EndDate.Text:=FormatDateTime('ddddd',SCalControl1.SelDateEnd);
end;

procedure TfrmDemo1.StartDateExit(Sender: TObject);
begin
  SCalControl1.SelDate:=StrToDateTime(StartDate.Text);
end;

procedure TfrmDemo1.EndDateExit(Sender: TObject);
begin
  SCalControl1.SelDateEnd:=StrToDateTime(EndDate.Text);
end;

procedure TfrmDemo1.SCalEdit1SelectDate(Sender: TObject);
begin
  ceStartDate.Text:=FormatDateTime('ddddd',SCalEdit1.SelDate);
  ceEndDate.Text:=FormatDateTime('ddddd',SCalEdit1.SelDateEnd);
end;

procedure TfrmDemo1.SCalEdit1SelectTime(Sender: TObject);
begin
  ceStartDate.Text:=FormatDateTime(LongTimeFormat,SCalEdit1.SelTime);
end;

procedure TfrmDemo1.ceStartDateExit(Sender: TObject);
begin
  if rgModeDT.ItemIndex=0 then
    SCalEdit1.SelDate:=StrToDate(ceStartDate.Text)
  else SCalEdit1.SelTime:=StrToTime(ceStartDate.Text);
end;

procedure TfrmDemo1.ceEndDateExit(Sender: TObject);
begin
  SCalEdit1.SelDateEnd:=StrToDateTime(ceEndDate.Text);
end;

procedure TfrmDemo1.rgShowButtonClick(Sender: TObject);
begin
  Case rgShowButton.ItemIndex of
    0: SCalEdit1.ButtonShow:=btnShowYes;
    1: SCalEdit1.ButtonShow:=btnShowNo;
    2: SCalEdit1.ButtonShow:=btnShowFocus;
  end; // Case
end;

procedure TfrmDemo1.rgButtonPosClick(Sender: TObject);
begin
  Case rgButtonPos.ItemIndex of
    0: SCalEdit1.ButtonAlign:=btnRight;
    1: SCalEdit1.ButtonAlign:=btnLeft;
  end; // Case
end;


procedure TfrmDemo1.rgModeDTClick(Sender: TObject);
begin
  Case rgModeDT.ItemIndex of
    0: begin With SCalEdit1 do begin Width:=185; TextOffset:=0;
    Font.Color:=clRed; Alignment:=taLeftJustify; DisplayMode:=dmDate; end;
       with rgShowButton do begin Enabled:=True;
         ItemIndex:=0; end; cbSpin.Checked:=False;
       ceStartDate.EditMask:='!99/99/00;1; ';
        Label5.Caption:='Start Date';
       SCalEdit1SelectDate(nil); end;
    1: begin With SCalEdit1 do begin Width:=98; TextOffset:=13;
        Font.Color:=clBlue; Alignment:=taRightJustify; DisplayMode:=dmTime; end;
       with rgShowButton do begin ItemIndex:=1;
         Enabled:=False; end; cbSpin.Checked:=True;
         ceStartDate.EditMask:='!90:00:00 >LL;1; ';
         Label5.Caption:='Time';
         SCalEdit1SelectTime(nil); end;
  end; // Case
  SCalEdit1.SetFocus;
end;

procedure TfrmDemo1.rgBorderStyle2Click(Sender: TObject);
begin
  Case rgBorderStyle2.ItemIndex of
    0:  With SCalEdit1 do begin
        ParentColor:=True; BorderStyle:=bsNone; end;
    1: With SCalEdit1 do begin
        Color:=clWindow; BorderStyle:=bsSingle; Ctl3D:=False; end;
    2: With SCalEdit1 do begin
        Color:=clWindow; BorderStyle:=bsSingle; Ctl3D:=True; end;
  end; // Case
end;

procedure TfrmDemo1.cbFloatClick(Sender: TObject);
begin
  SCalEdit1.Calendar.FloatCalendar:=cbFloat.Checked;
end;

procedure TfrmDemo1.cbQuickClick(Sender: TObject);
begin
  if cbQuick.Checked then begin
  SCalEdit1.SpinChangeType:=stSection;
  ShowMessage('You can now use the arrow keys to change the date/time.');
  SCalEdit1.SetFocus; end
  else begin SCalEdit1.SpinChangeType:=stNone;
    With cbSpin do begin
      OnClick:=nil; Checked:=cbQuick.Checked;
      OnClick:=cbSpinClick; end; end;
end;

procedure TfrmDemo1.cbSpinClick(Sender: TObject);
begin
  SCalEdit1.SpinButtons:=cbSpin.Checked;
end;

procedure TfrmDemo1.SCalEdit1DblClick(Sender: TObject);
begin
  SCalEdit1.DisplayForm(Sender);
end;


procedure TfrmDemo1.Label8DblClick(Sender: TObject);
  Var r: TPoint;
begin
  r:=Point(Panel2.Left,Panel2.Top);
  r:=frmDemo1.ClientToScreen(r);
  With SCalPopup1 do begin Visible:=False; SelDate:=Now;
    CalLeft:=r.x; CalTop:=r.y; Execute(Bevel1); end;
end;

procedure TfrmDemo1.FocusOnClickClick(Sender: TObject);
begin
  SCalControl1.FocusOnClick:=FocusOnClick.Checked;
end;

procedure TfrmDemo1.MaskEdit1DblClick(Sender: TObject);
begin
  With SCalPopup1 do begin
    Visible:=False; CalLeft:=-1; CalTop:=-1;
    SelDate:=StrToDateTime(TMaskEdit(Sender).Text);
    NumMonthsDown:=1; NumMonthsAcross:=2; Execute(Sender); end;
end;

procedure TfrmDemo1.MaskEdit2DblClick(Sender: TObject);
begin
  With SCalPopup1 do begin
    Visible:=False; CalLeft:=-1; CalTop:=-1;
    SelDate:=StrToDateTime(TMaskEdit(Sender).Text);
    NumMonthsDown:=1; NumMonthsAcross:=1; Execute(Sender); end;
end;

procedure TfrmDemo1.MaskEdit3DblClick(Sender: TObject);
begin
  With SCalPopup1 do begin
    Visible:=False; CalLeft:=-1; CalTop:=-1;
    SelDate:=StrToDateTime(TMaskEdit(Sender).Text);
    NumMonthsDown:=2; NumMonthsAcross:=1; Execute(Sender); end;
end;

procedure TfrmDemo1.MaskEdit4DblClick(Sender: TObject);
begin
  With SCalPopup1 do begin
    Visible:=False; CalLeft:=-1; CalTop:=-1;
    SelDate:=StrToDateTime(TMaskEdit(Sender).Text);
    NumMonthsDown:=2; NumMonthsAcross:=2; Execute(Sender); end;
end;

procedure TfrmDemo1.SCalPopup1SelectDate(Sender: TObject);
begin
  If Sender is TCustomEdit then TMaskEdit(Sender).Text:=
   FormatDateTime('ddddd',SCalPopup1.SelDate)
end;

procedure TfrmDemo1.cpFloatClick(Sender: TObject);
begin
  SCalPopup1.FloatCalendar:=cpFloat.Checked;
end;

procedure TfrmDemo1.TabControl1Change(Sender: TObject);
begin
  case TTabControl(Sender).TabIndex of
    0: Memo1.BringtoFront;
    1: Memo2.BringtoFront;
    2: Memo3.BringtoFront; end;
end;

procedure TfrmDemo1.SCalEdit1GetMonthInfo(Sender: TObject; Month: Integer;
  var MonthBoldInfo: LongInt);
begin
{  With SCalEdit1 do
    if(SelDate<>0)and(not Assigned(FSubForm))or
     (Assigned(FSubForm)and not FSubForm.Visible) then
      BoldDays([Trunc(Day-1),Trunc(Day+1),
      Trunc(Day-7),Trunc(Day+7)],MonthBoldInfo);}
end;

procedure TfrmDemo1.SCalControl1GetMonthInfo(Sender: TObject;
  Month: Integer; var MonthBoldInfo: LongInt);
var y,m,d: word;
begin
  DecodeDate(Now,y,m,d);
  With SCalControl1 do
    BoldDays([d],MonthBoldInfo);
end;

procedure TfrmDemo1.cbBoldDaysClick(Sender: TObject);
begin
  SCalControl1.Options.ShowDayState:=
    cbBoldDays.Checked;
end;

procedure TfrmDemo1.SCalEdit1Exit(Sender: TObject);
begin
  if SCalEdit1.Text='' then SCalEdit1.Text:='Drop Date Here!';
end;

procedure TfrmDemo1.SCalEdit1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:= (Source is TSCalControl);
end;

procedure TfrmDemo1.SCalEdit1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source is TSCalControl then begin
    TSCalEdit(Sender).SelDate:=
      TSCalControl(Source).SelDate;
    TSCalEdit(Sender).SelDateEnd:=
      TSCalControl(Source).SelDateEnd; end;
end;

procedure TfrmDemo1.SCalEdit1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    with Sender as TSCalEdit do
      BeginDrag(False);
end;

procedure TfrmDemo1.SCalControl1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TSCalEdit);
end;

procedure TfrmDemo1.SCalControl1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source is TSCalEdit then begin
    TSCalControl(Sender).SelDate:=
      TSCalEdit(Source).SelDate;
    TSCalControl(Sender).SelDateEnd:=
      TSCalEdit(Source).SelDateEnd; end;
end;

procedure TfrmDemo1.SCalControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then
    TSCalControl(Sender).BeginDrag(False);
end;

end.
